Subject: Re: [tcpm] On the implementation of TCP urgent data (IETF Internet Draft)

From: Fernando Gont <[email-masked]>
Date: Sat, 28 Feb 2009 18:36:38 -0200

Bill Squier wrote:

(Added Andrew Yourtchenko (draft co-author) to the recipient's list)

Comments inline...

> I haven't had time to read the article completely, but I did skim the
> Windows section, and Christos is correct.  

IIRC, we did the windows tests with cygwin. Maybe this is what lead to
different results?

That said, the next version of our Internet Draft will include text
describing the buggy implementations you are referring to.

> Further, I noticed that some of your analysis discusses OOB data
> bleeding in-line.  This is almost certainly caused by an interaction (on
> the _sender_) of Nagle and the fact that TCP defines only a single OOB
> pointer.  The receiver is not returning bytes which it knows to be OOB
> bytes inline, the _sender_ is accidentally placing more than a single
> byte of OOB in each packet that it sends.

There is no problem with that. TCP just provides a mechanism for marking
the end of urgent data. Just a mark.

> The receiver has no way to know that, as the only means of communication
> about OOB data between sender and receiver is a single pointer.

Exactly. Any data that's before the pointer should be considered "urgent".

Thanks!

Kind regards,
-- 
Fernando Gont
e-mail: [email-masked] || [email-masked]
PGP Fingerprint: 7809 84F5 322E 45C7 F1C9 3945 96EE A9EF D076 FFF1